#
# spec file for package rpm-python
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           rpm-python
Version:        4.11.2
Release:        14.13.1
#!BuildIgnore:  rpmlint-Factory
Summary:        Python Bindings for Manipulating RPM Packages
License:        GPL-2.0-or-later
Group:          System/Packages
Source99:       rpm.spec
BuildRequires:  file-devel
BuildRequires:  libacl-devel
BuildRequires:  libbz2-devel
BuildRequires:  libcap-devel
BuildRequires:  libelf-devel
BuildRequires:  libselinux-devel
BuildRequires:  libsemanage-devel
BuildRequires:  libtool
BuildRequires:  lua51-devel
BuildRequires:  ncurses-devel
BuildRequires:  popt-devel
BuildRequires:  python-devel
BuildRequires:  xz-devel
BuildRequires:  zlib-devel
Requires:       rpm = %{version}
%py_requires
%{expand:%(sed -n -e '/^Source:/,/^BuildRoot:/p' <%_sourcedir/rpm.spec)}
%global with_python 2

%description
The rpm-python package contains a module that permits applications
written in the Python programming language to use the interface
supplied by RPM Package Manager libraries.

This package should be installed if you want to develop Python programs
that will manipulate RPM packages and databases.

%prep
%{expand:%(sed -n -e '/^%%prep/,/^%%install/p' <%_sourcedir/rpm.spec | sed -e '1d' -e '$d')}

%install
mkdir -p %{buildroot}%{_prefix}/lib
# only installing in python/ does not work because rpm links against
# installed libs at install time
%make_install
find %{buildroot} -not -type d -and -not -path %{buildroot}%{_libdir}/python%{py_ver}/site-packages/rpm/\* -print0 | xargs -0 rm
pushd %{buildroot}/%py_sitedir/rpm
rm -f _rpm*.a _rpm*.la
python %py_libdir/py_compile.py *.py
python -O %py_libdir/py_compile.py *.py
popd

%files
%defattr(-,root,root)
%{_libdir}/python*/*/*

%changelog
* Wed Nov 20 2013 mls@suse.de
- adapt to python-3.3, which no longer looks at XXXmodule.so
* Fri Jul 12 2013 mls@suse.de
- update to rpm-4.11.1
* Wed Jan  2 2013 dmueller@suse.com
- Update to 4.10.2
* Mon Apr 23 2012 mls@suse.de
- modified capsule api diff to match rpm upstream
* Wed Apr 11 2012 klaussfreire@gmail.com
- Fix usage of deprecated AsVoidPtr Python/C API,
  replaced by Capsule API
* Tue Jan 17 2012 saschpe@suse.de
- Spec file cleanup:
  * Don't rm -rf %%{buildroot}
  * Removed %%clean section
  * Removed authors from description
* Sun Dec 11 2011 coolo@suse.com
- add libtool as explicit buildrequire
* Wed Feb 23 2011 mls@suse.de
- drop standard python directories from filelist [bnc#229189]
* Fri Oct 22 2010 coolo@novell.com
- adapt second spec file to changes done to rpm.spec
* Mon Oct 18 2010 dmueller@suse.de
- adapt buildrequires
* Thu Feb 12 2009 ro@suse.de
- adapt buildrequires
* Wed Oct  8 2008 cthiel@suse.de
- added libelf-devel to BuildRequires to fix build
* Thu Sep 11 2008 mls@suse.de
- update to 4.4.2.3 to get rid of >50 patches
* Sat Aug 30 2008 cthiel@suse.de
- add libselinux-devel to BuildRequires
* Thu Aug  7 2008 dmueller@suse.de
- fix build against python 2.6
* Thu Mar 27 2008 coolo@suse.de
- fix buildrequires
* Fri May 25 2007 mls@suse.de
- fix unicode queries
* Fri Mar 30 2007 rguenther@suse.de
- add ncurses-devel and zlib-devel BuildRequires.
* Wed Oct 18 2006 mls@suse.de
- use rpm.spec for building instead of duplication everything
- delete superfluous .a and .la files [#202604]
- create .pyc and .pyo files [#205711]
* Sun Oct 15 2006 schwab@suse.de
- Make sure config.rpath is present.
* Fri Sep 22 2006 aj@suse.de
- Fix for python2.5.
* Thu Sep 21 2006 lnussel@suse.de
- do not package beecrypt python bindings as libbeecrypt is not
  packaged either
- fix literal %%{version} in Requires tag
* Thu Sep 21 2006 lnussel@suse.de
- fix build with python 2.5 by overriding autodetection
* Tue Sep 19 2006 rguenther@suse.de
- split from rpm package
